package widebase.rq

import msgpack.rpcx.auth.AuthMap

import vario.data.Datatype
import vario.filter.StreamFilter
import vario.filter.StreamFilter.StreamFilter

import widebase.rq.handler.BrokerHandler

/** RQ Broker.
 *
 * @param path to persistence
 * @param jaas entry name
 * @param auths procedure based authorizations
 * @param filter self-explenatory
 *
 * @author myst3r10n
 */
class Broker(
  path: String,
  jaas: String,
  auths: AuthMap,
  interval: Int,
  filter: StreamFilter = StreamFilter.None)
  extends msgpack.rpcx.Server {

  /** Alternative constructor.
   *
   * @param handler alternative
   */
  def this(handler: BrokerHandler) = {

    this(null, null, null, 0, null)

    this.handler = handler

  }

  if(path != null)
    handler = new BrokerHandler(path, this, jaas, auths, interval, filter)

  override def handler = super.handler.asInstanceOf[BrokerHandler]

  def handler_=(handler: BrokerHandler) = {

    super.handler = handler

    this

  }

  override def release {

    super.release
    handler.release

  }
}

