package widebase.rq

import widebase.rq.interface.ProducerInterface

/** Producer Client
 *
 * @param host of server
 * @param port of server
 * @param username to login
 * @param password to login
 *
 * @author myst3r10n
 */
class ProducerClient(
  host: String,
  port: Int,
  username: String = "",
  password: String = "")
  extends Client(host, port, username, password)
  with ProducerProxy {

  /** proxy to [[widebase.rq.ProducerInterface]]. */
  override protected val proxy = client.proxy(classOf[ProducerInterface])

}

