package widebase.rq

import msgpack.rpcx.Proxy

import widebase.db.table.Table
import widebase.rq.interface.ProducerInterface

/** Proxy to [[widebase.rq.ProducerInterface]].
 *
 * @author myst3r10n
 */
trait ProducerProxy extends Proxy {

  import vario.filter.StreamFilter.StreamFilter

  /** Proxy to producer interface. */
  protected val proxy: ProducerInterface

  /** Shutdown server remotelly. */
  def remoteShutdown {

    proxy.remoteShutdown(authId)

  }

  /** Upsert records.
   *
   * @param name of table
   * @param table to upsert
   * @param filter to pack binary records
   */
  def upsert(
    name: String,
    table: Table,
    filter: StreamFilter = props.filters.upsert) {

    proxy.upsert(authId, name, table.toBytes(filter))

  }
}

